Bug 112744 - Float at exact multiple of line-height affects too many lines in Chrome
Summary: Float at exact multiple of line-height affects too many lines in Chrome
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Layout and Rendering (show other bugs)
Version: 528+ (Nightly build)
Hardware: Macintosh OS X 10.7
: P2 Normal
Assignee: Dave Hyatt
URL:
Keywords: AdobeTracked
Depends on:
Blocks:
 
Reported: 2013-03-19 14:32 PDT by Alan Stearns
Modified: 2013-04-16 10:55 PDT (History)
15 users (show)

See Also:


Attachments
file to reproduce problem (647 bytes, text/html)
2013-03-19 14:32 PDT, Alan Stearns
no flags Details
Patch (40.23 KB, patch)
2013-03-29 06:59 PDT, Robert Hogan
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from gce-cr-linux-01 for chromium-linux-x86_64 (1.41 MB, application/zip)
2013-03-29 08:49 PDT, WebKit Review Bot
no flags Details
Archive of layout-test-results from webkit-ews-10 for mac-mountainlion-wk2 (578.22 KB, application/zip)
2013-03-29 09:20 PDT, Build Bot
no flags Details
Patch (40.31 KB, patch)
2013-03-30 00:25 PDT, Robert Hogan
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from gce-cr-linux-03 for chromium-linux-x86_64 (1.20 MB, application/zip)
2013-03-30 01:31 PDT, WebKit Review Bot
no flags Details
Archive of layout-test-results from webkit-ews-09 for mac-mountainlion-wk2 (632.40 KB, application/zip)
2013-03-30 01:33 PDT, Build Bot
no flags Details
Patch (59.14 KB, patch)
2013-03-30 01:57 PDT, Robert Hogan
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from webkit-ews-14 for mac-mountainlion-wk2 (561.20 KB, application/zip)
2013-03-30 04:04 PDT, Build Bot
no flags Details
Patch (8.39 KB, patch)
2013-04-13 08:44 PDT, Robert Hogan
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from webkit-ews-07 for mac-mountainlion (556.87 KB, application/zip)
2013-04-13 12:03 PDT, Build Bot
no flags Details
Archive of layout-test-results from webkit-ews-04 for mac-mountainlion (562.48 KB, application/zip)
2013-04-13 12:56 PDT, Build Bot
no flags Details
Archive of layout-test-results from webkit-ews-13 for mac-mountainlion-wk2 (651.95 KB, application/zip)
2013-04-13 16:26 PDT, Build Bot
no flags Details
Patch (23.70 KB, patch)
2013-04-14 02:39 PDT, Robert Hogan
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from webkit-ews-07 for mac-mountainlion (565.04 KB, application/zip)
2013-04-14 04:54 PDT, Build Bot
no flags Details
Archive of layout-test-results from webkit-ews-14 for mac-mountainlion-wk2 (565.79 KB, application/zip)
2013-04-14 22:28 PDT, Build Bot
no flags Details
Patch (21.22 KB, patch)
2013-04-15 11:20 PDT, Robert Hogan
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Alan Stearns 2013-03-19 14:32:14 PDT
Created attachment 193923 [details]
file to reproduce problem

If you have a float whose height is a multiple of the surrounding text's line height (all specified in ems) Mac Chrome will wrap one more line than is necessary. Mac Safari (also tested Mac Firefox, Mac Opera and IE10) wrap the correct number of lines.
Comment 1 Levi Weintraub 2013-03-19 15:14:02 PDT
This bug likely occurs because line-heights are truncated to integers (see m_lineHeight in RenderBlock) but boxes use sub-pixel values. This is a bug, but I don't intend to tackle this soon.
Comment 2 Dave Hyatt 2013-03-20 08:31:04 PDT
I'll fix this one.
Comment 3 Dave Hyatt 2013-03-20 08:51:35 PDT
Making m_lineHeight a LayoutUnit did not fix this bug, so I think there's something else going on here.
Comment 4 Robert Hogan 2013-03-21 00:05:54 PDT
(In reply to comment #3)
> Making m_lineHeight a LayoutUnit did not fix this bug, so I think there's something else going on here.

I think FloatIntervalSearchAdapter needs to be converted to LayoutUnit too.
Comment 5 Robert Hogan 2013-03-29 06:59:35 PDT
Created attachment 195742 [details]
Patch
Comment 6 WebKit Review Bot 2013-03-29 07:17:52 PDT
Comment on attachment 195742 [details]
Patch

Attachment 195742 [details] did not pass cr-linux-debug-ews (chromium-xvfb):
Output: http://webkit-commit-queue.appspot.com/results/17296843
Comment 7 WebKit Review Bot 2013-03-29 08:49:22 PDT
Comment on attachment 195742 [details]
Patch

Attachment 195742 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://webkit-commit-queue.appspot.com/results/17357504

New failing tests:
fast/multicol/vertical-rl/float-multicol.html
Comment 8 WebKit Review Bot 2013-03-29 08:49:27 PDT
Created attachment 195753 [details]
Archive of layout-test-results from gce-cr-linux-01 for chromium-linux-x86_64

The attached test failures were seen while running run-webkit-tests on the chromium-ews.
Bot: gce-cr-linux-01  Port: chromium-linux-x86_64  Platform: Linux-3.3.8-gcg-201212281604-x86_64-with-GCEL-10.04-gcel_10.04
Comment 9 Build Bot 2013-03-29 09:20:07 PDT
Comment on attachment 195742 [details]
Patch

Attachment 195742 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-commit-queue.appspot.com/results/17354555

New failing tests:
fast/backgrounds/background-position-parsing.html
Comment 10 Build Bot 2013-03-29 09:20:10 PDT
Created attachment 195755 [details]
Archive of layout-test-results from webkit-ews-10 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-10  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.2
Comment 11 Robert Hogan 2013-03-30 00:25:51 PDT
Created attachment 195846 [details]
Patch
Comment 12 WebKit Review Bot 2013-03-30 01:31:39 PDT
Comment on attachment 195846 [details]
Patch

Attachment 195846 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://webkit-commit-queue.appspot.com/results/17374168

New failing tests:
http/tests/workers/terminate-during-sync-operation.html
fast/multicol/vertical-rl/float-multicol.html
Comment 13 WebKit Review Bot 2013-03-30 01:31:43 PDT
Created attachment 195848 [details]
Archive of layout-test-results from gce-cr-linux-03 for chromium-linux-x86_64

The attached test failures were seen while running run-webkit-tests on the chromium-ews.
Bot: gce-cr-linux-03  Port: chromium-linux-x86_64  Platform: Linux-3.3.8-gcg-201212281604-x86_64-with-GCEL-10.04-gcel_10.04
Comment 14 Build Bot 2013-03-30 01:33:20 PDT
Comment on attachment 195846 [details]
Patch

Attachment 195846 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-commit-queue.appspot.com/results/17256598

New failing tests:
fast/backgrounds/background-position-parsing.html
Comment 15 Build Bot 2013-03-30 01:33:23 PDT
Created attachment 195849 [details]
Archive of layout-test-results from webkit-ews-09 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-09  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.2
Comment 16 Robert Hogan 2013-03-30 01:57:18 PDT
Created attachment 195850 [details]
Patch
Comment 17 Build Bot 2013-03-30 04:04:42 PDT
Comment on attachment 195850 [details]
Patch

Attachment 195850 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-commit-queue.appspot.com/results/17340831

New failing tests:
fast/backgrounds/background-position-parsing.html
Comment 18 Build Bot 2013-03-30 04:04:46 PDT
Created attachment 195853 [details]
Archive of layout-test-results from webkit-ews-14 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-14  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.2
Comment 19 Robert Hogan 2013-04-13 08:44:11 PDT
Created attachment 197942 [details]
Patch
Comment 20 Build Bot 2013-04-13 12:03:03 PDT
Comment on attachment 197942 [details]
Patch

Attachment 197942 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/143207

New failing tests:
fast/backgrounds/background-position-parsing.html
http/tests/ssl/ping-with-unsafe-redirect.html
Comment 21 Build Bot 2013-04-13 12:03:07 PDT
Created attachment 197951 [details]
Archive of layout-test-results from webkit-ews-07 for mac-mountainlion

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: webkit-ews-07  Port: mac-mountainlion  Platform: Mac OS X 10.8.2
Comment 22 Build Bot 2013-04-13 12:56:55 PDT
Comment on attachment 197942 [details]
Patch

Attachment 197942 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/143219

New failing tests:
fast/backgrounds/background-position-parsing.html
http/tests/ssl/ping-with-unsafe-redirect.html
Comment 23 Build Bot 2013-04-13 12:56:57 PDT
Created attachment 197953 [details]
Archive of layout-test-results from webkit-ews-04 for mac-mountainlion

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: webkit-ews-04  Port: mac-mountainlion  Platform: Mac OS X 10.8.2
Comment 24 Build Bot 2013-04-13 16:26:27 PDT
Comment on attachment 197942 [details]
Patch

Attachment 197942 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/143257

New failing tests:
fast/backgrounds/background-position-parsing.html
http/tests/ssl/ping-with-unsafe-redirect.html
Comment 25 Build Bot 2013-04-13 16:26:30 PDT
Created attachment 197961 [details]
Archive of layout-test-results from webkit-ews-13 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-13  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.2
Comment 26 Robert Hogan 2013-04-14 02:39:13 PDT
Created attachment 197980 [details]
Patch
Comment 27 Build Bot 2013-04-14 04:54:03 PDT
Comment on attachment 197980 [details]
Patch

Attachment 197980 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/69145

New failing tests:
fast/backgrounds/background-position-parsing.html
http/tests/ssl/ping-with-unsafe-redirect.html
Comment 28 Build Bot 2013-04-14 04:54:06 PDT
Created attachment 197985 [details]
Archive of layout-test-results from webkit-ews-07 for mac-mountainlion

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: webkit-ews-07  Port: mac-mountainlion  Platform: Mac OS X 10.8.2
Comment 29 Build Bot 2013-04-14 22:28:38 PDT
Comment on attachment 197980 [details]
Patch

Attachment 197980 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/113285

New failing tests:
fast/backgrounds/background-position-parsing.html
http/tests/ssl/ping-with-unsafe-redirect.html
Comment 30 Build Bot 2013-04-14 22:28:41 PDT
Created attachment 198022 [details]
Archive of layout-test-results from webkit-ews-14 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-14  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.2
Comment 31 Robert Hogan 2013-04-15 11:20:54 PDT
Created attachment 198139 [details]
Patch
Comment 32 Dave Hyatt 2013-04-16 10:19:39 PDT
Comment on attachment 198139 [details]
Patch

r=me
Comment 33 WebKit Commit Bot 2013-04-16 10:54:59 PDT
Comment on attachment 198139 [details]
Patch

Clearing flags on attachment: 198139

Committed r148523: <http://trac.webkit.org/changeset/148523>
Comment 34 WebKit Commit Bot 2013-04-16 10:55:03 PDT
All reviewed patches have been landed.  Closing bug.